require "blocks"
require "chunk"
require "world"
require "entity"
require "menu"
require "player"
require "ui_button"
require "ui_dial"
require "world_generator"
require "debug_menu"

function love.load()
    Debug_mode = false
    Current_player = Player.new(0, 0)
    grass = love.graphics.newImage("art/grass.png")
    block_width = grass:getWidth()
    block_height = grass:getHeight()
    block_depth = block_height / 2
    grid_size = 30
    grid = {}
    for x = 1,grid_size do
       grid[x] = {}
       for y = 1,grid_size do
          grid[x][y] = 1
       end
    end

    camera = {x = love.graphics.getWidth()/2, y = love.graphics.getHeight()/2, speed = 300}
end 

function love.update(dt)
    camera_move(dt)
    local screen = {}
    screen.x, screen.y = love.mouse.getPosition()
    screen.x = math.floor(screen.x)
    screen.y = math.floor(screen.y)

    local grid_x = math.floor((camera.x + screen.x) / block_width + screen.y / block_height / 2)
    local grid_y = math.floor((camera.y + screen.y) / block_height - screen.x / block_width / 2)
    print(grid_x, grid_y)
    if grid_x < 1 or grid_x > grid_size or grid_y < 1 or grid_y >grid_size then return 
    else 
        grid[grid_x][grid_y]= 0
    end
end

function love.draw()

    for x = 1,grid_size do
        for y = 1,grid_size do
            if grid[x][y] > 0 then
                love.graphics.draw(grass,
                ( camera.x + (x-y) * (block_width / 2)),
                 camera.y + (x+y) * (block_height / 4))
            end
        end
     end
    Debug:draw()
end

function camera_move(dt)
    if love.keyboard.isDown("w") then 
        camera.y = camera.y - camera.speed * dt 
    end
    if love.keyboard.isDown("a") then 
        camera.x = camera.x - camera.speed * dt 
    end
    if love.keyboard.isDown("s") then 
        camera.y = camera.y + camera.speed * dt 
    end
    if love.keyboard.isDown("d") then 
        camera.x = camera.x + camera.speed * dt 
    end
end   love.window.setVSync(0)
 

function love.keypressed(key)
    if key == "escape" then 
        love.event.quit()
    end
    Debug:keypressed(key)        
end